// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IBonDriver2.h"
#include "TsUtilClass.h"
#include "UsbFx2Driver.h"
#include "../../SharedEcm/EcmDat.h"
#include <vector>
#include <queue>

#define REMOCON_CMD_LEN		8	//e`l̃R񐔂̍ő

using std::vector;
using std::queue;


class CBonTuner : public IBonDriver2, protected IUsbFx2DriverHost
{
public:
	CBonTuner();
	virtual ~CBonTuner();

	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

// IBonDriver2(b)
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

	/*̕Ӓǉ*/
	BOOL InitTunerProperty(void);
	BOOL IRCodeTX(BYTE code);
	BOOL IRButtonTX(BYTE button);
	BYTE ConvButtonToCode(BYTE button);


protected:
	virtual const bool OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver);
	void AllocFifoBuff(void);
	void FreeFifoBuff(void);

	inline void PushFifoBuff(const BYTE *pData);
	
	CUsbFx2Driver *m_pUsbFx2Driver;
	CCriticalLock m_CriticalLock;
	HANDLE m_hOnStreamEvent;

	queue<BYTE *> m_FifoBuffer;
	vector<vector<BYTE>> m_BufferPool;
	DWORD m_dwEmptyFifoPos;

	BOOL is_channel_valid;

	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	// jf`[i[̃vpeB
	TCHAR m_szTunerName[100] ;
	int m_nChannels ;
	BYTE m_yFx2Id ;

	DWORD m_dwFifoThreadIndex;
	DWORD m_dwFifoBcasThreadIndex;
	CEcmDat* m_pEcm;
};
