// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"

#pragma comment(lib, "SetupApi.lib")


//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// MTCY
#define TSDATASIZE			65536UL										// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		4UL											// obt@ = 4b
#define ASYNCBUFFSIZE		( 0x800000 / TSDATASIZE * ASYNCBUFFTIME )	// 64MbpsƂ

// Gh|CgCfbNX
#define EPINDEX_IN			0UL
#define EPINDEX_OUT			1UL

// R}h
//#define CMD_EP6IN_START		0x50U	//
//#define	CMD_EP6IN_STOP		0x51U	//
#define	CMD_PORT_CFG		0x54U	//addr_mask, out_pins
#define	CMD_PORT_READ		0x57U	//(return 1byte)
#define	CMD_PORT_WRITE		0x58U	//value
#define	CMD_IFCONFIG		0x59U	//value
#define	CMD_MODE_IDLE		0x5AU
#define CMD_IR_WBUF			0x5EU	//len(max 60), data, ....
//#define CMD_EP4IN_START		0x5BU	// B-CAS
//#define CMD_EP4IN_STOP		0x5CU	// B-CAS
#define CMD_TSBCAS_INIT		0x70U	// TS - BCAS VNX^[g
#define CMD_TSBCAS_START	0x71U	// TS - BCAS VNX^[g
#define CMD_TSBCAS_END		0x72U	// TS - BCAS I

#define	PIO_START			0x20
#define	PIO_IR_OUT			0x10
#define PIO_TS_BACK			0x04
#define PIO_TERRESTRIAL		0x02
#define PIO_POWERSENSE 		0x01

// FX2t@[EFA
static const BYTE abyFirmWare[0x10000] =
#include "Fw.inc"

//////////////////////////////////////////////////////////////////////
// `l`e[u
//////////////////////////////////////////////////////////////////////

// `le[u
const struct {
	LPCTSTR pszSpace ;
	LPCTSTR pszChName ;
	DWORD dWait ;
	char aszRCode[30] ;
	char aszPad[6] ;
} asCh[] = {
	{ TEXT("nfW"), TEXT("R 1"),              2000, ".TT....11..11.." },
	{ TEXT("nfW"), TEXT("R 2"),              2000, ".TT....22..22.." },
	{ TEXT("nfW"), TEXT("R 3"),              2000, ".TT....33..33.." },
	{ TEXT("nfW"), TEXT("R 4"),              2000, ".TT....44..44.." },
	{ TEXT("nfW"), TEXT("R 5"),              2000, ".TT....55..55.." },
	{ TEXT("nfW"), TEXT("R 6"),              2000, ".TT....66..66.." },
	{ TEXT("nfW"), TEXT("R 7"),              2000, ".TT....77..77.." },
	{ TEXT("nfW"), TEXT("R 8"),              2000, ".TT....88..88.." },
	{ TEXT("nfW"), TEXT("R 9"),              2000, ".TT....99..99.." },
	{ TEXT("nfW"), TEXT("R 10"),             2000, ".TT....AA..AA.." },
	{ TEXT("nfW"), TEXT("R 11"),             2000, ".TT....BB..BB.." },
	{ TEXT("nfW"), TEXT("R 12"),             2000, ".TT....CC..CC.." },
	{ TEXT("BS"),     TEXT("BS1/TS0 BS"),          2000, ".SS....55..55.." },
	{ TEXT("BS"),     TEXT("BS1/TS1 BS-i"),            2000, ".SS....66..66.." },
	{ TEXT("BS"),     TEXT("BS3/TS0 WOWOW"),           2000, ".SS....99..99.." },
	{ TEXT("BS"),     TEXT("BS3/TS1 BSWp"),      2000, ".SS....77..77.." },
	{ TEXT("BS"),     TEXT("BS9/TS0 BS11"),            2000, ".SS....BB..BB.." },
	{ TEXT("BS"),     TEXT("BS9/TS1 Star Channel HV"), 2000, ".SS....AA..AA.." },
	{ TEXT("BS"),     TEXT("BS9/TS2 TwellV"),          2000, ".SS....CC..CC.." },
	{ TEXT("BS"),     TEXT("BS13/TS0 BSe"),       2000, ".SS....44..44.." },
	{ TEXT("BS"),     TEXT("BS13/TS1 BStW"),         2000, ".SS....88..88.." },
	{ TEXT("BS"),     TEXT("BS15/TS1 NHK BS1/2"),      2000, ".SS....11..11.." },
	{ TEXT("BS"),     TEXT("BS15/TS2 NHK BS-hi"),      2000, ".SS....33..33.." },
	{ TEXT("110CS"),  TEXT("ND2 110CS #1"),            2500, "..MMMMM...YYY.111...RR.." },
	{ TEXT("110CS"),  TEXT("ND4 110CS #2"),            2500, "..MMMMM...YYY.222...RR.." },
	{ TEXT("110CS"),  TEXT("ND6 110CS #3"),            2500, "..MMMMM...YYY.333...RR.." },
	{ TEXT("110CS"),  TEXT("ND8 110CS #4"),            2500, "..MMMMM...YYY.444...RR.." },
	{ TEXT("110CS"),  TEXT("ND10 110CS #5"),           2500, "..MMMMM...YYY.555...RR.." },
	{ TEXT("110CS"),  TEXT("ND12 110CS #6"),           2500, "..MMMMM...YYY.666...RR.." },
	{ TEXT("110CS"),  TEXT("ND14 110CS #7"),           2500, "..MMMMM...YYY.777...RR.." },
	{ TEXT("110CS"),  TEXT("ND16 110CS #8"),           2500, "..MMMMM...YYY.888...RR.." },
	{ TEXT("110CS"),  TEXT("ND18 110CS #9"),           2500, "..MMMMM...YYY.999...RR.." },
	{ TEXT("110CS"),  TEXT("ND20 110CS #10"),          2500, "..MMMMM...YYY.AAA...RR.." },
	{ TEXT("110CS"),  TEXT("ND22 110CS #11"),          2500, "..MMMMM...YYY.BBB...RR.." },
	{ TEXT("110CS"),  TEXT("ND24 110CS #12"),          2500, "..MMMMM...YYY.CCC...RR.." },
} ;

// RR[h
const struct {
	char cChar ;
	BYTE yCode ;
} asRc[] = {
	{ '0', 0xdc },	// [10/0]
	{ '1', 0xe8 },	// [1]
	{ '2', 0xe7 },	// [2]
	{ '3', 0xe6 },	// [3]
	{ '4', 0xe4 },	// [4]
	{ '5', 0xe3 },	// [5]
	{ '6', 0xe2 },	// [6]
	{ '7', 0xe0 },	// [7]
	{ '8', 0xdf },	// [8]
	{ '9', 0xde },	// [9]
	{ 'A', 0xdc },	// [10/0]
	{ 'B', 0xdb },	// [11]
	{ 'C', 0xda },	// [12]
	{ 'T', 0xd0 },  // [n]
	{ 'S', 0xcf },	// [BS]
	{ 'N', 0xd7 },	// [`lԍ]
	{ 'M', 0xec },	// [j[]
	{ 'Y', 0xd2 },	// []
	{ 'R', 0xeb },	// [߂]
	{ 'P', 0xf8 },	// [d](gO)
	{ 'G', 0xf7 },	// [ʕ\](ԑg\𒆎~)
	{ '_', 0xc0 },	// ȃR[h(R[h𑗂Ƃɋ)
	{ '.', 0x00 },	// 1t[(108ms)EFCg
	{ 0,   0x00 }
} ;

//////////////////////////////////////////////////////////////////////
// fobOp
//////////////////////////////////////////////////////////////////////

void DebugPrintF( const char* pszFormat,... )
{
	va_list	marker ;
	char edit_str[4096] ;
	va_start( marker, pszFormat ) ;
	vsprintf_s( edit_str, sizeof(edit_str), pszFormat, marker ) ;
	va_end( marker ) ;
	OutputDebugStringA( edit_str ) ;
}

//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	LogPrintf( "\fCreateBonDriver()Ăяo<o[W %s>\n", __TIMESTAMP__ ) ;
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
	: m_pUsbFx2Driver(NULL)
	, m_hOnStreamEvent(NULL)
	, m_hThreadEvent(NULL)
	, m_hThread(NULL)
	, m_pEcm(NULL)
{
	m_pEcm = new CEcmDat;
	m_pEcm->SetDiag(FALSE);
	m_pThis = this;
	InitTunerProperty() ;
}

CBonTuner::~CBonTuner()
{
	if (m_pEcm) {
		m_pEcm->exit();
		delete m_pEcm;
	}
	// JĂꍇ͕
	CloseTuner();
	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	LogPrintf( "\fCBonTuner::OpenTuner()Ăяo\n" ) ;
	//Ƃ肠Xg[Ƃ߂
	m_bIsChValid = FALSE;

	// UN[Y
	CloseTuner();

	// JIUSB FX2̃hCoCX^X
	m_pUsbFx2Driver = new CUsbFx2Driver(this);
	if(!m_pUsbFx2Driver) {
		LogPrintf( "    ERROR! : new CUsbFx2Driver(this)Ɏs\n" ) ;
		return false;
	}
	
	// FX2̏V[PX
	try{
		// FIFOobt@m
		AllocFifoBuff();

		// Cxg쐬
		if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL))) {
			LogPrintf( "    ERROR! : m_hOnStreamEvent = ::CreateEvent()Ɏs\n" ) ;
			throw 0UL;
		}
		if(!(m_hThreadEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL))) {
			LogPrintf( "    ERROR! : m_hThreadEvent = ::CreateEvent()Ɏs\n" ) ;
			throw 0UL;
		}
		// Xg[ĊJpXbh̋N
		if ( !( m_hThread = CreateThread( NULL, 0, ThreadAfterSetChannel,
			this, 0, NULL ) ) ) {
			LogPrintf( "    ERROR! : m_hThread = ::CreateThread()Ɏs\n" ) ;
			throw 0UL;
		}

		// hCoI[v(fobOrhł̓t@Ct@[_E[h)
		#ifdef _DEBUG
		FILE* pFile ;
		if ( fopen_s( &pFile, "fifo.iic", "rb" ) ) {
			LogPrintf( "    ERROR! : fifo.iic̓ǂݍ݂Ɏs\n" ) ;
			throw 0UL ;
		}
		BYTE abyTmp[sizeof(abyFirmWare)] ;
		fread( abyTmp, 1, sizeof(abyFirmWare), pFile ) ;
		fclose( pFile ) ;
		if(!m_pUsbFx2Driver->OpenDriver( m_yFx2Id, abyTmp, NULL)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->OpenDriver()Ɏs\n" ) ;
			throw 0UL;
		}
		#else
		if(!m_pUsbFx2Driver->OpenDriver( m_yFx2Id, abyFirmWare, FW_NAME)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->OpenDriver()Ɏs\n" ) ;
			throw 0UL;
		}
		#endif

		// Gh|Cgǉ
		if(!m_pUsbFx2Driver->AddEndPoint(0x81U)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->AddEndPoint(0x81U)Ɏs\n" ) ;
			throw 1UL;
		}
		if(!m_pUsbFx2Driver->AddEndPoint(0x01U)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->AddEndPoint(0x01U)Ɏs\n" ) ;
			throw 2UL;
		}
		
		// FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		if(!m_pUsbFx2Driver->TransmitFormatedData(EPINDEX_OUT, 6UL,
			CMD_PORT_CFG, 0x00U, PIO_START|PIO_IR_OUT|PIO_TS_BACK|PIO_TERRESTRIAL,
			CMD_MODE_IDLE,
			CMD_IFCONFIG, 0xE3U)) {
			LogPrintf( "    ERROR! : TransmitFormatedData()Ɏs\n" ) ;
			throw 3UL;
		}

		// XbhN
		if(!m_pUsbFx2Driver->CreateFifoThread(0x86U, &m_dwFifoThreadIndex, TSDATASIZE)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->CreateFifoThread()Ɏs\n" ) ;
			throw 4UL;
		}
		if(!m_pUsbFx2Driver->CreateFifoThread(0x84U, &m_dwFifoBcasThreadIndex, 512, 1)) {
			LogPrintf( "    ERROR! : m_pUsbFx2Driver->CreateFifoThread()Ɏs (B-CAS)\n" ) ;
			throw 4UL;
		}

		// JnR}hM
		if(!m_pUsbFx2Driver->TransmitFormatedData(EPINDEX_OUT, 4UL,
			CMD_TSBCAS_INIT, CMD_TSBCAS_START,
			CMD_PORT_WRITE, PIO_START|PIO_IR_OUT|PIO_TS_BACK)) {
			LogPrintf( "    ERROR! : TransmitFormatedData(Jn)Ɏs\n" ) ;
			throw 3UL;
		}

		// d
		if ( !PowerOn() ) {
			LogPrintf( "    ERROR! : Power(I)Ɏs\n" ) ;
			throw 5UL;
		}

		return TRUE;
	}
	catch(DWORD dwErrorStep){
		// G[
		dwErrorStep += 0 ; // to avoid warnning4101
		CloseTuner();
		return FALSE;
	}

}

void CBonTuner::CloseTuner()
{
	// Xg[ĊJpXbh̒~
	if ( m_hThread ) {
		if ( m_hThreadEvent ) ::SetEvent(m_hThreadEvent) ;
		WaitForSingleObject( m_hThread, INFINITE ) ;
		CloseHandle( m_hThread ) ;
		m_hThread = NULL ;
	}

	// hCo
	if(m_pUsbFx2Driver){
		LogPrintf( "\fCBonTuner::CloseTuner()Ăяo\n" ) ;

		// ~R}hM
		m_pUsbFx2Driver->TransmitFormatedData(EPINDEX_OUT, 3UL,
			CMD_PORT_WRITE, PIO_IR_OUT|PIO_TS_BACK|PIO_TERRESTRIAL,
			CMD_TSBCAS_END ) ;

		// d؂
		PowerOff() ;

		// hCo
		m_pUsbFx2Driver->CloseDriver();
		delete m_pUsbFx2Driver;
		m_pUsbFx2Driver = NULL;		
	}

	// Cxgnh
	if(m_hThreadEvent){
		::CloseHandle(m_hThreadEvent);
		m_hThreadEvent = NULL;	
	}
	if(m_hOnStreamEvent){
		::CloseHandle(m_hOnStreamEvent);
		m_hOnStreamEvent = NULL;	
	}

	// obt@J
	FreeFifoBuff();

	// ̑
	m_bIs1stSetCh = TRUE ;
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	LogPrintf( "\fCBonTuner::SetChannel(%d)Ăяo\n", bCh ) ;

	//Ƃ肠Xg[Ƃ߂
	m_bIsChValid = FALSE;

	// ȃ`l
	if(bCh < 0 || bCh >= m_nChannels) {
		LogPrintf( "    ERROR! : `lԍ\n" ) ;
		return FALSE;
	}

	//nfWEBS/CS̐ؑ
	if ( bCh < 12 ) {
		LogPrintf( "    TS͂nfWɐؑ\n" ) ;
		m_pUsbFx2Driver->TransmitFormatedData(EPINDEX_OUT, 2UL,
			CMD_PORT_WRITE, PIO_START | PIO_IR_OUT | PIO_TS_BACK | PIO_TERRESTRIAL ) ;
	}
	else {
		LogPrintf( "    TS͂BS/CSɐؑ\n" ) ;
		m_pUsbFx2Driver->TransmitFormatedData(EPINDEX_OUT, 2UL,
			CMD_PORT_WRITE, PIO_START | PIO_IR_OUT | PIO_TS_BACK ) ;
	}

	// dONŏ̑IǂȂQ񑗂 (2008/08/08KQ񑗂ɕύX)
	char aszRCode[60] ;
	strcpy_s( aszRCode, sizeof(aszRCode), asCh[bCh].aszRCode ) ;
	DWORD dWait = asCh[bCh].dWait ;
	//if ( m_bIs1stSetCh ) {
		//dWait = dWait + strlen( asCh[bCh].aszRCode ) * 108 ;
		strcat_s( aszRCode, sizeof(aszRCode), asCh[bCh].aszRCode ) ;
		//LogPrintf( "    dONŏȂ̂2񑗂\n" ) ;
	//}

	// Rf[^𑗂
	LogPrintf( "    RR[h \"%s\"\n", aszRCode ) ;
	if ( !NecRemoCon( aszRCode ) ) {
		LogPrintf( "    ERROR! : NecRemoCon()Ɏs\n" ) ;
		return FALSE ;
	}

	// TSf[^p[W
	PurgeTsStream();

	// sӂɓd؂gủ񕜗p
	strcpy_s( m_aszLastCode, sizeof(m_aszLastCode), aszRCode ) ;
	m_nTsLastTimer = m_nTsRestartTimer ;

	// w莞ԌɃXg[̎荞݂ĊJ߂̃Xbh쐬
	//LogPrintf( "    Xg[ĊJ܂ł̎ = %dms\n", dWait ) ;
	m_nTsRestartTimer = dWait ;

	return TRUE;
}

const float CBonTuner::GetSignalLevel(void)
{
	// VOix̂FIFOobt@FullnessԂ
	return ((float)m_FifoBuffer.size() / (float)ASYNCBUFFSIZE * 100.0f);
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_pUsbFx2Driver)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_pUsbFx2Driver)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
	}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_FifoBuffer.size();
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	// TSf[^obt@o
	BYTE *pSrc = NULL;
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
		}
		return TRUE;
	}
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock Lock(&m_CriticalLock);

	if(!m_pUsbFx2Driver)return FALSE;

	// TSf[^obt@o
	if(m_FifoBuffer.size()){
		// f[^Rs[
		*pdwSize = TSDATASIZE;
		*ppDst = m_FifoBuffer.front();
		m_FifoBuffer.pop();
		*pdwRemain = m_FifoBuffer.size() ;
		return TRUE;
	}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;
		return TRUE;
	}
}

void CBonTuner::PurgeTsStream()
{
	LogPrintf( "\fCBonTuner::PurgeTsStream()Ăяo\n" ) ;
	CBlockLock Lock(&m_CriticalLock);
	// ̃f[^p[W
	while(!m_FifoBuffer.empty()) m_FifoBuffer.pop();
}

void CBonTuner::Release()
{
	LogPrintf( "\fCBonTuner::Release()Ăяo\n" ) ;
	// CX^XJ
	delete this;
}

LPCTSTR CBonTuner::GetTunerName(void)
{
	LogPrintf( "\fCBonTuner::GetTunerName()Ăяo\n" ) ;
	// `[iԂ
	return m_szTunerName ;
}

const BOOL CBonTuner::IsTunerOpening(void)
{
	// `[i̎gp̗LԂ(SvZXʂ)
	if( m_pUsbFx2Driver != NULL ) return TRUE;
	else return FALSE;
}

LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	//LogPrintf( "\fCBonTuner::EnumTuningSpace(%d)Ăяo\n", dwSpace ) ;
	// 0͍ŏ̋ԂԂ
	if ( dwSpace == 0 ) {
		return asCh[0].pszSpace ;
	}
	// ̋ԖT
	DWORD dwSpcIdx = 0 ;
	int nIdx0 = 0 ;
	for ( int nIdx = 0 ; nIdx < m_nChannels ; nIdx++ ) {
		if ( !_tcscmp( asCh[nIdx0].pszSpace, asCh[nIdx].pszSpace ) ) continue ;
		nIdx0 = nIdx ;
		dwSpcIdx++ ;
		if ( dwSpace == dwSpcIdx ) return asCh[nIdx].pszSpace ;
	}
	return NULL ;
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	//LogPrintf( "\fCBonTuner::EnumChannelName(%d,%d)Ăяo\n", dwSpace, dwChannel ) ;
	// Ԗ擾
	LPCTSTR pszSpace = EnumTuningSpace( dwSpace ) ;
	if ( !pszSpace ) return NULL ;
	// Ԗ̈v`lT
	DWORD dwChIdx = 0 ;
	for ( int nIdx = 0 ; nIdx < m_nChannels ; nIdx++ ) {
		if ( _tcscmp( pszSpace, asCh[nIdx].pszSpace ) ) continue ;
		if ( dwChIdx == dwChannel ) return asCh[nIdx].pszChName ;
		dwChIdx++ ;
	}
	return NULL ;
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// Ԗ擾
	LPCTSTR pszSpace = EnumTuningSpace( dwSpace ) ;
	if ( !pszSpace ) return FALSE ;
	// Ԗ̈v`lT
	DWORD dwChIdx = 0 ;
	for ( int nIdx = 0 ; nIdx < m_nChannels ; nIdx++ ) {
		if ( _tcscmp( pszSpace, asCh[nIdx].pszSpace ) ) continue ;
		if ( dwChIdx == dwChannel ) {
			// `lݒ肷
			if( SetChannel((BYTE)nIdx) == TRUE ){
				m_dwCurSpace = dwSpace;
				m_dwCurChannel = dwChannel;
				return TRUE;
			}else{
				return FALSE;
			}
		}
		dwChIdx++ ;
	}
	return FALSE ;
}

const DWORD CBonTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

BOOL CBonTuner::InitTunerProperty(void)
{
	//̖O擾
	char szMyPath[_MAX_PATH] ;
	GetModuleFileNameA( m_hModule, szMyPath, _MAX_PATH ) ;
	char szMyName[_MAX_FNAME] ;
	_splitpath_s( szMyPath, NULL, 0,NULL, 0, szMyName, _MAX_FNAME, NULL, 0 ) ;
	_strupr_s( szMyName, sizeof(szMyName) ) ;
	// ̖OFX2-IDƓdON̑҂Ԃ
	int nFx2Id = 0 ;
	int nWait = 0 ;
	if ( !sscanf_s( szMyName, "BONDRIVER_D4ID%1d%1d", &nFx2Id, &nWait ) ) {
		LogPrintf( "    ERROR! : DLLȂID=0(ftHg)gp\n" ) ;
	}
	m_yFx2Id = BYTE(nFx2Id) ;
	m_nWaitAfterPon = ( nWait >= 0 && nWait <= 9 ) ? nWait : 0 ;
	LogPrintf( "    FX2-ID=%d dON҂=%db\n", nFx2Id, m_nWaitAfterPon ) ;
	//`[i[
	_stprintf_s( m_szTunerName, 100, TEXT("DT400(ID=%d)"), nFx2Id ) ;
	//̑̏
	m_nChannels = (sizeof(asCh)/sizeof(asCh[0])) ;
	return TRUE ;
}

void CBonTuner::AllocFifoBuff(void)
{
	// FIFOobt@p[W
	PurgeTsStream();

	// obt@v[mۂ
	m_BufferPool.resize(ASYNCBUFFSIZE);

	for(DWORD dwPos = 0UL ; dwPos < ASYNCBUFFSIZE ; dwPos++){
		m_BufferPool[dwPos].resize(TSDATASIZE);
	}

	m_dwEmptyFifoPos = 0UL;
}

void CBonTuner::FreeFifoBuff(void)
{
	// FIFOobt@p[W
	PurgeTsStream();

	// obt@v[J
	m_BufferPool.clear();
}

BOOL CBonTuner::PowerOn( void )
{
	LogPrintf( "\fCBonTuner::PowerOn()Ăяo\n" ) ;
	// ONłȂΓd(gO)𑗂
	if ( !GetPowerState() ) {
		if ( !NecRemoCon( "P.....G" ) ) {
			LogPrintf( "    ERROR! : NecRemoCon( \"P\" )Ɏs\n" ) ;
			return FALSE ;
		}
	}
	else {
		LogPrintf( "    ɓdONĂ\n" ) ;
	}
	// 12bȓONłȂG[Ƃ
	int nTime ;
	WORD wPowerState = 0x5555 ;
	for ( nTime = 0 ; nTime < 120 ; nTime++ ) {
		Sleep( 100 ) ;
		if ( GetPowerState() ) wPowerState = ( wPowerState << 1 ) | 1 ;
		else wPowerState = ( wPowerState << 1 ) | 0 ;
		// 8(0.8b)ԓ_ȂOFFƐ̂ŁAēxd(gO)𑗂
		if ( ( wPowerState & 0xff ) == 0x00 ) {
			NecRemoCon( "P.....G" ) ;
			LogPrintf( "    ERROR! : 0.8bԓ_Ȃ̂ŁAēxNecRemoCon( \"P\" )\n" ) ;
			wPowerState = 0x5555 ;
		}
		// 16(1.6b)ԏȂON
		else if ( wPowerState == 0xffff ) break ;
		// ȊOȂ_Œ
		else ;
	}
	// dONs
	if ( wPowerState != 0xffff ) {
		LogPrintf( "    ERROR! : 12b҂LED͏Ȃ\n" ) ;
		return FALSE ;
	}
	// dON
	LogPrintf( "    dnmmF܂ł̎=%dms\n", nTime * 100 ) ;
	// t@CŐݒ肵ǉ̑҂
	Sleep( m_nWaitAfterPon * 1000 ) ;
	return TRUE ;
}

BOOL CBonTuner::PowerOff( void )
{
	LogPrintf( "\fCBonTuner::PowerOff()Ăяo\n" ) ;
	// OFFłȂΓd(gO)𑗂
	if ( GetPowerState() ) {
		if ( !NecRemoCon( "P" ) ) {
			LogPrintf( "    ERROR! : NecRemoCon( \"P\" )Ɏs\n" ) ;
			return FALSE ;
		}
	}
	else {
		LogPrintf( "    ERROR! : ɓdOFFĂ\n" ) ;
	}
	// 12bȓOFFłȂG[Ƃ
	int nTime ;
	WORD wPowerState = 0x5555 ;
	for ( nTime = 0 ; nTime < 120 ; nTime++ ) {
		Sleep( 100 ) ;
		if ( GetPowerState() ) wPowerState = ( wPowerState << 1 ) | 1 ;
		else wPowerState = ( wPowerState << 1 ) | 0 ;
		// 8(0.8b)ԏȂONƐ̂ŁAēxd(gO)𑗂
		if ( ( wPowerState & 0xff ) == 0xff ) {
			NecRemoCon( "P" ) ;
			LogPrintf( "    ERROR! : 0.8bԏȂ̂ŁAēxNecRemoCon( \"P\" )\n" ) ;
			wPowerState = 0x5555 ;
		}
		// 16(1.6b)ԓ_ȂOFF
		else if ( wPowerState == 0x0000 ) break ;
		// ȊOȂ_Œ
		else ;
	}
	// dOFFs
	if ( wPowerState != 0x0000 ) {
		LogPrintf( "    ERROR! : 12b҂LED͓_Ȃ\n" ) ;
		return FALSE ;
	}
	// dOFF
	LogPrintf( "    dneemF܂ł̎=%dms\n", nTime * 100 ) ;
	return TRUE ;
}

BOOL CBonTuner::GetPowerState( void )
{
	// ݂̓d̏Ԃ擾
	BYTE yCmd = CMD_PORT_READ ;
	DWORD len = 1 ;
	if( !m_pUsbFx2Driver->TransmitData(EPINDEX_OUT,&yCmd,len)) return FALSE;
	BYTE yPort ;
	len = 1 ;
	if( !m_pUsbFx2Driver->TransmitData(EPINDEX_IN,&yPort,len)) return FALSE;
	// ON?
	if ( yPort & PIO_POWERSENSE ) return TRUE ;
	else return FALSE ;
}

BOOL CBonTuner::NecRemoCon( const char* pszCode )
{
	BYTE cmd[64] ;
	DWORD len = 0 ;
	cmd[len++] = CMD_IR_WBUF ;
	cmd[len++] = (BYTE)strlen( pszCode ) ;
	// R[hɕϊ
	int i ;
	char c ;
	for ( i = 0 ; c = pszCode[i] ; i++ ) {
		int j ;
		for ( j = 0 ; asRc[j].cChar ; j++ ) {
			if ( asRc[j].cChar == c ) break ;
		}
		cmd[len++] = asRc[j].yCode ;
	}
	// `[i[ɑ
	if( !m_pUsbFx2Driver->TransmitData(EPINDEX_OUT,cmd,len)) return FALSE;

	return TRUE ;
}

const bool CBonTuner::OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver)
{
	if (dwThreadIndex == m_dwFifoThreadIndex) {
		//Lȃ`lIĂ鎞Ɍ
		if(m_bIsChValid){
			// FIFOobt@ɃvbV
			PushFifoBuff(pData);
		}
		// CxgZbg
		::SetEvent(m_hOnStreamEvent);
	}
	else if (dwThreadIndex == m_dwFifoBcasThreadIndex) {
		m_pEcm->set(pData, dwLen);
	}

	return true;
}

void CBonTuner::PushFifoBuff(const BYTE *pData)
{
	CBlockLock Lock(&m_CriticalLock);

	// obt@v[̍ő吔𒴂ꍇ͂Săp[W
	if ( m_FifoBuffer.size() >= ASYNCBUFFSIZE -1 ) {
		while(!m_FifoBuffer.empty()) m_FifoBuffer.pop();
	}

	// obt@v[Ƀf[^Rs[
	BYTE *pWritePointer = &m_BufferPool[m_dwEmptyFifoPos][0];
	::CopyMemory(pWritePointer, pData, TSDATASIZE);

	// FIFOobt@ɃvbV
	m_FifoBuffer.push(pWritePointer);

	// obt@v[ʒuXV
	if(++m_dwEmptyFifoPos >= ASYNCBUFFSIZE)m_dwEmptyFifoPos = 0UL;
}

DWORD CBonTuner::ThreadAfterSetChannel( LPVOID lpParameter )
{
	// w莞ԌTS擾ĊJ
	CBonTuner* pThis = (CBonTuner*)lpParameter ;
	pThis->m_nTsRestartTimer = 0 ;
	while ( TRUE ) {
		if ( WaitForSingleObject( pThis->m_hThreadEvent, 100 ) !=
			WAIT_TIMEOUT ) break ;
		if ( pThis->m_nTsRestartTimer > 0 ) {
			pThis->m_nTsRestartTimer -= 100 ;
			if ( pThis->m_nTsRestartTimer <= 0 ) {
				LogPrintf( "\fThreadAfterSetChannel()Cxg\n" ) ;
				// d؂Ă΁Ađ蒼ATSĊJăXPW[
				if ( !pThis->GetPowerState() ) {
					///**/MessageBeep( MB_ICONEXCLAMATION ) ;
					LogPrintf( "    ERROR! : dOFFoōēxdON/`lđM\n" ) ;
					pThis->PowerOn() ;
					pThis->NecRemoCon( pThis->m_aszLastCode ) ;
					pThis->m_nTsRestartTimer = pThis->m_nTsLastTimer ;
				}
				else {
					///**/MessageBeep( MB_OK ) ;
					pThis->m_bIsChValid = TRUE ;
					pThis->m_bIs1stSetCh = FALSE ;
					LogPrintf( "    ThreadAfterSetChannel()Xg[oĊJ\n" ) ;
				}
			}
		}
	}
	return 0 ;
}
