// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IBonDriver2.h"
#include "TsUtilClass.h"
#include "UsbFx2Driver.h"
#include "../../SharedEcm/EcmDat.h"
#include <vector>
#include <queue>

using std::vector;
using std::queue;

class CBonTuner : public IBonDriver2, protected IUsbFx2DriverHost
{
// RXgN^EfXgN^
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
public:
	const BOOL OpenTuner(void);
	void CloseTuner(void);
	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);
	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);
	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);
	void PurgeTsStream(void);
	void Release(void);

// IBonDriver2(b)
public:
	LPCTSTR GetTunerName(void);
	const BOOL IsTunerOpening(void);
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);
	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

// [`
private:
	BOOL InitTunerProperty(void);
	void AllocFifoBuff(void);
	void FreeFifoBuff(void);
	BOOL PowerOn( void ) ;
	BOOL PowerOff( void ) ;
	BOOL GetPowerState( void ) ;
	BOOL NecRemoCon( const char* pszCode ) ;
	const bool OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver);
	void PushFifoBuff(const BYTE *pData);
	static DWORD WINAPI ThreadAfterSetChannel( LPVOID lpParameter ) ;
// g̃|C^Enh
public:
	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;
// `[i[̃vpeB
private:
	TCHAR m_szTunerName[100] ;
	int m_nChannels ;
	BYTE m_yFx2Id ;
	int m_nWaitAfterPon ;
// hCo[̊Ǘ
	CUsbFx2Driver *m_pUsbFx2Driver;
	CCriticalLock m_CriticalLock;
	HANDLE m_hOnStreamEvent;
// f[^obt@̊Ǘ
	queue<BYTE *> m_FifoBuffer;
	vector<vector<BYTE>> m_BufferPool;
	DWORD m_dwEmptyFifoPos;
// Xg[ĊJpXbh̊Ǘ
	HANDLE m_hThreadEvent ;
	HANDLE m_hThread ;
	int m_nTsRestartTimer ;
// sӂɓd؂gủ񕜗p
	int m_nTsLastTimer ;
	char m_aszLastCode[60] ;
// ̑
	BOOL m_bIsChValid;
	BOOL m_bIs1stSetCh;
	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	DWORD m_dwFifoThreadIndex;
	DWORD m_dwFifoBcasThreadIndex;
	CEcmDat* m_pEcm;
};
