module bcas_ser2par(CLK, IO, DATA, REQ, REQ_CLR);
	input  CLK;
	input  IO;
	output [7:0] DATA;
	output REQ;
	input  REQ_CLR;

	reg frame;
	reg req;
	reg [11:0] bit_cnt;
	reg [7:0] sreg;
	reg [3:0] num_bits;
	reg [7:0] dout;
	reg [2:0] ios;
	
	always@(posedge CLK or posedge REQ_CLR)
	begin
		if(REQ_CLR == 1)
			req <= 0;
		else begin
			if((num_bits == 8) && (bit_cnt == 0)) begin
				dout <= sreg;
				req <= 1;
			end
		end
	end
	
	wire _io = ios[0] & ios[1] & ios[2];

	//for noise
	always@(posedge CLK)
	begin
		ios[2:1] <= ios[1:0];
		ios[0] <= IO;
	end

	always@(posedge CLK)
	begin
	
		if((frame == 0)&&(_io == 0)) begin
			frame <= 1;
			bit_cnt <= (93+186)*12;
			num_bits <= 0;
		end

		if(num_bits == 10)
			frame <= 0;
			
		if(frame == 1) begin
			bit_cnt <= bit_cnt - 1;
			if(bit_cnt == 0) begin
				num_bits <= num_bits + 1;
				sreg[6:0] <= sreg[7:1];
				sreg[7] <= _io;
				bit_cnt <= 186*12;
			end
		end
	end

	assign REQ = req;
	assign DATA = dout;
endmodule
