#pragma once
#include "windows.h"

#include "RingBuffer.h"

typedef struct _ECM_DAT{
	BYTE key[25];
	ULONG magic;
	DWORD time;
}ECM_DAT;

#include "SharedEcmQueue.h"

// Critical Section Lapper
class CEcmDat
{
public:
	CEcmDat();
	~CEcmDat();

	void set(const BYTE* data,ULONG size);
	int size(void){ return (int)m_q.size(); }
	ECM_DAT get(ULONG magic,BOOL &ret);
	void SetDiag(BOOL flg){m_diagmode = flg;}
	void exit(void);
	void GetKsKey(const BYTE* cmd,ULONG len,BYTE* ret);
	
private:

	CRingBuffer*		m_pbuf;
	CSharedEcmQueue m_q;
	HANDLE m_handle;
	BOOL m_exit;
	BOOL m_diagmode;
	BOOL m_start;
	CRITICAL_SECTION m_CriticalSection;
};
